#!/usr/bin/perl
#
# blogch - ǼBlogޤBlogηǼ
#
# Copyright (c) 2004 Satoshi Fukutomi <fuktommy@inter7.jp>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: blogch.cgi,v 1.20 2004/12/28 09:11:29 fuktommy Exp $
#

use lib qw(. lib);
use strict;
use Blogch;
use vars qw(%cookie @newcookie);

#
# 
#
my $CSS_URI		= "/blogch.css";
my $LICENCE_RDF		= "/licence.rdf";
my $LICENCE_IMG		= "src='/somerights20.gif' width='88' height='31'";
my $LICENCE_URI		= "http://creativecommons.org/licenses/by/2.0/jp/";
my $LICENCE		= "ꥨƥ֡󥺡饤";
my $SELF_URI		= "/blogch.cgi";			# URI
my $ABS_URI		= "http://example.com/blogch.cgi";	# URI(URI)
my $GOOGLE_URI		= "http://www.google.co.jp/search";
my $TITLE		= "blogch";				# ΤΥȥ
my $DESCRIPTION		= "ǼBlogޤBlogηǼ"; # Ȥδñ
my $MAIL_ADDRESS	= 'fuktommy@inter7.jp';			# ʤΥ᡼륢ɥ쥹
my $SAVE_COOKIE		= 365*24*60*60;				# å¸()
my $ATTACH_URI		= "/upload";				# źեեURI
my $SEARCH_PREFIX	= "$SELF_URI?cmd=search&amp;msg=";	# URI
my $ANONYMOUS_ENTORY	= 1;					# üԤǤ⵭뤫ɤ(0/1)
$Blogch::DATA_DIR	= "./data";				# ǡ񤭹Ȥ
$Blogch::ATTACH_DIR	= "./upload";				# źեե񤭹Ȥ
$Blogch::ART_LIMIT	= 10240;				# 񤭹ߤκ祵(Bytes)
$Blogch::STAMP_CACHE	= 5*24*60*60;				# ɤΤ餤Ť񤭹ߤޤɽ뤫()
umask 0000;

my $SELF_URI_REWRITE	= $SELF_URI; $SELF_URI_REWRITE =~ s|/$||;
my $ABS_URI_REWRITE	= $ABS_URI;  $ABS_URI_REWRITE  =~ s|/$||;

#
# å
#
my %message = (
	new	=> "",
	thismon	=> "",
	index	=> "",
	recent	=> "ǿ",
	search	=> "",
	rss	=> "ۿ",
	view	=> "ɸ",
	edit	=> "Խ",
	setting	=> "",
	help	=> "",
	error	=> "顼",
	comment	=> "",
	passwd	=> "ѥ",
	google	=> "Google",
	year	=> "ǯ",
	mon	=> "",
	day	=> "",
	keyword	=> "",
	attach	=> "źեե",
	suffix	=> "ĥ",
	remove	=> "",
	trackback=> "ȥåХå",
	entry	=> "",
	thisEntry => "ε",
	thisEntryName => "ε̾",
	licence => "ε<a rel='license' href='$LICENCE_URI'>$LICENCE</a>βǥ饤󥹤Ƥޤ",
);

#
# 
#
sub xlocaltime($) {
	my @buf = localtime($_[0]);
	return sprintf "%d-%02d-%02d %02d:%02d",
		       1900+$buf[5], $buf[4]+1, $buf[3], $buf[2], $buf[1];
}

#
# Cookie
#
sub printCookie() {
	local $_;
	foreach (@newcookie) {
		print "Set-Cookie: $_=", encode($cookie{$_});
		if ($SAVE_COOKIE) {
			print "; expires=", rfc822_time(time + $SAVE_COOKIE);
		}
		print ";\n";
	}
	
}

#
# إåȤ
# $opt{deny_robot}, $opt{date}
#
sub printHeader($;%) {
	my($title, %opt) = @_;
	local $_;
	$title = "" unless (defined $title);
	my $str_title = encode(unescape($title));
	print "Content-Type: text/html; charset=EUC-JP\r\n";
	printCookie();
#	print "Last-Modified: ", rfc822_time(stamp($opt{date})), "\r\n" if ($opt{date});
	print "\r\n",
	      "<?xml version='1.0' encoding='EUC-JP'?>\n",
	      "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.1//EN'\n",
	      "  'http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd'>\n",
	      "<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='ja'>\n",
	      "<head>\n",
	      "  <meta name='description' content='$DESCRIPTION' />\n";
	print "  <meta name='robots' content='NOINDEX' />\n" if ($opt{deny_robot});
	print "  <title>$title - $TITLE</title>\n",
	      "  <link rev='made' href='mailto:$MAIL_ADDRESS' />\n",
	      "  <link rel='contents' href='$SELF_URI' />\n",
	      "  <link rel='index' href='$SELF_URI?cmd=index' />\n",
	      "  <link rel='stylesheet' type='text/css' href='$CSS_URI' />\n",
	      "  <link rel='alternate' type='application/rdf+xml' title='RSS' href='$SELF_URI?cmd=rss' />\n",
	      "  <link rel='meta' type='application/rdf+xml' title='licence' href='$LICENCE_RDF' />\n",
	      "</head>\n",
	      "<body>\n",
	      "<p class='header'>\n",
	      "  <a href='$SELF_URI'>$message{recent}</a> |\n",
	      "  <a href='$SELF_URI?cmd=thismon'>$message{thismon}</a> |\n",
	      "  <a href='$SELF_URI?cmd=index'>$message{index}</a> |\n",
	      "  <a href='$SEARCH_PREFIX'>$message{search}</a> |\n",
	      "  <a href='$SELF_URI?cmd=rss'>$message{rss}</a> |\n";
	print "  <a href='$SELF_URI_REWRITE/$opt{date}.html'>$message{view}</a> |\n",
	      "  <a href='$SELF_URI?cmd=edit&amp;msg=$opt{date}'>$message{edit}</a> |\n"
	      if ($opt{date});
	print "  <a href='$SELF_URI?cmd=new'>$message{new}</a> |\n",
	      "  <a href='$SELF_URI?cmd=setting'>$message{setting}</a> |\n",
	      "  <a href='$SELF_URI?cmd=help'>$message{help}</a> ",
	      "<br />\n";
	my @keyword = readNamedFile("keyword");
	foreach (@keyword) {
		$_ = "  <a href='$SEARCH_PREFIX" . encode(unescape($_)) . "' title='$message{search}'>[[$_]]</a>";
	}
	print join(" /\n", @keyword);
	if ($opt{date}) {
		print " /\n" if (@keyword);
		print "  <a href='$SEARCH_PREFIX$opt{date}' title='$message{search}'>($message{thisEntry})</a> /\n",
		   "  <a href='$SEARCH_PREFIX$str_title' title='$message{search}'>($message{thisEntryName})</a>";
	}
	print "\n</p>\n",
	      "<h1>$title</h1>\n";
	print "<h2>* ", xlocaltime($opt{date}), "</h2>\n" if ($opt{date});
}

#
# 
#
sub print302($) {
	my($next) = @_;
	local $_;
	print "Content-Type: text/html;\r\n";
	printCookie();
	print "\r\n",
	      "<?xml version='1.0' encoding='iso-8859-1'?>\n",
	      "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.1//EN'\n",
	      "  'http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd'>\n",
	      "<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en'>\n",
	      "<head>\n",
	      "  <title>moved</title>\n",
	      "  <link rev='made' href='mailto:$MAIL_ADDRESS' />\n",
	      "  <link rel='contents' href='$SELF_URI' />\n",
	      "</head>",
	      "<body><p>Click and jump to <a href='$next'>$next</a></p>\n",
	      "<script type='text/javascript'>window.location.href = '$next';</script>\n",
	      "</body>\n</html>\n";
}

#
# եå
# $opt{licence}
#
sub printFooter(%) {
	my %opt = @_;
	print "<p class='footer'>";
	print "<a rel='licence' href='$LICENCE_URI'><img alt='$LICENCE' $LICENCE_IMG /></a><br />\n",
	      "$message{licence}<br />\n"
	      if ($opt{licence});
	print "Powered by <a href='http://fuktommy.s64.xrea.com/blogch/'>blogch</a>.",
	      "</p>\n</body>\n</html>\n";
}

#
# ̤ν
#
sub bracket_link($) {
	local($_) = @_;
	if (/^\d+$/) {
		return ("$SELF_URI_REWRITE/$_.html", $message{entry});
	} else {
		return ($SEARCH_PREFIX . encode(unescape($_)),    $message{search});
	}
}

#
# HTMLؤѷ
#
sub html_format($) {
	local($_) = @_;
	s|\n|<br />\n|g;
	s|^\*([^<>]+)<br />|</p><h2>*$1</h2><p>|gm;
	s|https?://[^\x00-\x20"'()<>\[\]\x7F-\xFF]{2,}|<a href='$&'>$&</a>|g;
	s|\[\[<a.*?>(.*?)\]\]</a>|[[$1]]|g;
	s|\[\[([^<>]+?)\]\]|sprintf("<a href='%s' title='%s'>[[%s]]</a>",bracket_link($1),$1)|eg;
	return $_;
}

#
# 顼
#
sub printError($) {
	my($msg) = @_;
	printHeader($message{error}, deny_robot=>1);
	print "<p>$message{error}: $msg</p>\n";
	printFooter();
	exit;
}

#
# ɸŪʥ
#
sub printCalender(;$$) {
	my($year, $mon);
	if (@_) {
		($year, $mon) = @_;
	} else {
		my %date = date();
		($year, $mon) = ($date{year}, $date{mon});
	}
	printHeader("$year$message{year}$mon$message{mon}");
	local $_;
	print "<ul>\n";
	foreach (sort {$b <=> $a} list($year, $mon)) {
		my $title = peep($_);
		print "<li>", xlocaltime($_), " <a href='$SELF_URI_REWRITE/$_.html'>$title</a></li>\n";
	}
	print "</ul>\n";
	printFooter();
}

#
# RSS1.0
#
sub printRss1Page() {
	my %date = date();
	my ($year, $mon) = ($date{year}, $date{mon});
	my $f;
	my %stamp = stamp_cache();
	my @file = sort {$stamp{$b} <=> $stamp{$a}} keys(%stamp);
	print "Content-Type: text/xml; charset=EUC-JP\r\n",
	      "Last-Modified: ", rfc822_time($stamp{$file[0]}||0), "\r\n",
	      "\r\n",
	      "<?xml version='1.0' encoding='EUC-JP'?>\n",
	      "<rdf:RDF\n",
	      "  xmlns='http://purl.org/rss/1.0/'\n",
	      "  xmlns:rdf='http://www.w3.org/1999/02/22-rdf-syntax-ns#'\n",
	      "  xmlns:dc='http://purl.org/dc/elements/1.1/'\n",
	      "  xml:lang='ja'>\n",
	      "<channel rdf:about='$ABS_URI?cmd=rss'>\n",
	      "  <title>$TITLE</title>\n",
	      "  <link>$ABS_URI</link>\n",
	      "  <description>$DESCRIPTION</description>\n",
	      "  <items><rdf:Seq>\n";
	foreach $f (@file) {
		print "    <rdf:li rdf:resource='$ABS_URI_REWRITE/$f.html' />\n";
	}
	print "  </rdf:Seq></items>\n</channel>\n";
	foreach $f (@file) {
		my $last = w3c_time($stamp{$f});
		print "<item rdf:about='$ABS_URI_REWRITE/$f.html'>\n",
		      "  <title>", peep($f), "</title>\n",
		      "  <link>$ABS_URI_REWRITE/$f.html</link>\n",
		      "  <dc:date>$last</dc:date>\n",
		      "</item>\n";
	}
	print "</rdf:RDF>\n";
}

#
# ΰ
#
sub printIndex() {
	printHeader($message{index});
	local $_;
	print "<ul>\n";
	foreach (reverse mon()) {
		print "<li><a href='$SELF_URI_REWRITE/$$_{year}/$$_{mon}/'>",
		      "$$_{year}$message{year}$$_{mon}$message{mon}</a></li>\n";
	}
	print "</ul>\n";
	printFooter();
}

#
# ɽ
#
sub printRecent(;$) {
	my($show) = @_;
	$show = $Blogch::STAMP_CACHE unless (defined $show);
	printHeader($message{recent});
	local $_;
	my @page = ();
	my $now	 = time;
	my %stamp = stamp_cache();
	while (my($k, $v) = each(%stamp)) {
		if ($v >= $now - $show) {
			push @page, "<li>" . xlocaltime($v) . " <a href='$SELF_URI_REWRITE/$k.html'>" .
				    peep($k) . "</a></li>\n";
		}
	}
	@page = sort {$b cmp $a} @page;
	print "<ul>\n";
	print @page;
	print "</ul>\n";
	printFooter();
}

#
# ɽ
#
sub printPage($) {
	my($file) = @_;
	my %date = date($file);
	my @buf	 = readFile($file);
	my $title = (@buf)? shift @buf: "";
	printHeader($title, date=>$file);
	print "<p>\n", html_format(join "\n", @buf),
	      "\n</p>\n";

	my $attach = attach($file);
	if ($attach) {
		print "<p><a href='$ATTACH_URI/$attach'>$attach</a></p>";
	}

	print "<form method='post' action='$SELF_URI?cmd=comment&amp;msg=$file'><p>\n",
	      "<input type='submit' value='$message{comment}' name='submit' tabindex='1' accesskey='w' /><br />\n",
	      "<textarea rows='10' cols='70' name='body' tabindex='8' accesskey='c'></textarea><br />\n",
	      "  $message{trackback} URI: $ABS_URI?cmd=trackback&amp;msg=$file<br />\n",
	      "  ", size($file), " byte / $Blogch::ART_LIMIT byte\n",
	      "</p></form>\n";
	print "<!--\n",
	      "  <rdf:RDF xmlns:rdf='http://www.w3.org/1999/02/22-rdf-syntax-ns#'\n",
	      "     xmlns:dc='http://purl.org/dc/elements/1.1/'\n",
	      "     xmlns:trackback='http://madskills.com/public/xml/rss/module/trackback/'>\n",
	      "  <rdf:Description\n",
	      "    rdf:about='$ABS_URI_REWRITE/$file.html'\n",
	      "    dc:identifer='$ABS_URI_REWRITE/$file.html'\n",
	      "    dc:title='$title'\n",
	      "    trackback:ping='$ABS_URI?cmd=trackback&amp;msg=$file' />\n",
	      "  </rdf:RDF>\n",
	      "-->\n";
	printFooter(licence=>1);
}

#
# Խڡ
#
sub printEditPage($) {
	my($file) = @_;
	my %date = date($file);
	my @buf = readFile($file);
	my $passwd = $cookie{PASSWD}? $cookie{PASSWD}: "";
	printHeader($buf[0], , deny_robot=>1, date=>$file);
	print "<p>\n", html_format(join "\n", @buf[1..$#buf]),
	      "\n</p>\n";

	print "<form method='post' action='$SELF_URI?cmd=trackbackpage&amp;msg=$file'><p>\n",
	      "  <input type='submit' value='$message{trackback}' name='submit' tabindex='1' accesskey='w' />\n",
	      "  <input value='' name='url' tabindex='2' accesskey='p' />\n",
	      "</p></form>\n" if (stamp($file));

	print "<form method='post' action='$SELF_URI?cmd=post&amp;msg=$file' enctype='multipart/form-data'><p>\n",
	      "  <input type='submit' value='$message{edit}' name='submit' tabindex='1' accesskey='w' />",
	      "<input type='hidden' value='", stamp($file) ,"' name='stamp' />",
	      " $message{passwd}<input type='password' value='$passwd' name='passwd' tabindex='2' accesskey='p' /><br />";

	my $attach = attach($file);
	if ($attach) {
		print "$message{attach} <a href='$ATTACH_URI/$attach'>$attach</a> $message{remove}",
		      "<input type='checkbox' name='remove' value='remove' tabindex='2' accesskey='r' /><br />\n";
	} else {
		print $message{attach},
		      "<input type='file' name='attach' tabindex='2' accesskey='a' />",
		      "($message{suffix}<input name='suffix' value='' tabindex='2' accesskey='s' />)<br />\n";
	}

	print "  <textarea rows='10' cols='70' name='body' tabindex='8' accesskey='c'>",
	      escapeForm(join "\n", @buf), "</textarea><br />\n",
	      "  ", size($file), " byte / $Blogch::ART_LIMIT byte\n",
	      "</p></form>";
	printFooter();
}

#
# Խ
# $opt{body}, $opt{stamp}, $opt{passwd}
#
sub post($%) {
	my($file, %opt) = @_;
	printError($message{passwd}) unless (checkPasswd($opt{passwd}));
	if ($opt{attach} && ${$opt{attach}}) {
		my $suffix = "txt";
		if ((defined $opt{suffix}) && ($opt{suffix} ne "")) {
			$suffix = $opt{suffix};
		} elsif ((defined $opt{auto_suffix}) && ($opt{auto_suffix} ne "")) {
			$suffix = $opt{auto_suffix};
		}
		my $filename = "$file.$suffix";
		writeAttach($filename, ${$opt{attach}}) or printError($filename);
	} elsif ($opt{remove}) {
		removeAttach($file);
	}
	writeFile($file, $opt{body}, stamp=>$opt{stamp}) or printError($file);
	print302("$SELF_URI_REWRITE/$file.html");
}

#
# Ȥɵ
# $opt{body}
#
sub comment($%) {
	my($file, %opt) = @_;
	if ((! defined $opt{body}) || ($opt{body} eq "")) {
		printError($file);
	} elsif ($ANONYMOUS_ENTORY && (! size($file))) {
		writeFile($file, $opt{body}, mode=>">>") or printError($file);
	} elsif (! size($file)) {
		printError($file);
	} else {
		my $date = xlocaltime(time);
		writeFile($file, "\n\n* $date\n$opt{body}", mode=>">>") or printError($file);
	}
	print302("$SELF_URI_REWRITE/$file.html");
}

#
# ȥåХå
#
sub trackback($%) {
	my($file, %opt) = @_;
	%opt = jcode_convert(%opt);
	my $date = xlocaltime(time);
	my $body = "\n\n* $date\n$opt{title} - $opt{blog_name}\n$opt{url}\n";
	print "Content-Type: text/xml\r\n",
	      "\r\n",
	      "<?xml version='1.0' encoding='iso-8859-1'?>\n",
	      "<response>\n";
	if ($opt{url} && writeFile($file, $body, mode=>">>")) {
		print "  <error>0</error>\n";
	} else {
		print "  <error>1</error>\n",
		      "  <message>Error</message>\n";
	}
	print "</response>\n";
}

#
# ȥåХåե
# $opt{tburl}
#
sub trackbackForm(%) {
	my(%opt) = @_;
	local $_;
	print "\n<form method='post' action=\"$opt{tburl}\"><p>",
	      "$opt{tburl}<br />",
	      "Title: <input name='title' value=\"$opt{title}\" accesskey='t' tabindex='1' /><br />",
	      "URL: <input name='url' value=\"$opt{url}\" accesskey='u' tabindex='1' /><br />",
	      "Excerpt: <input name='excerpt' value=\"$opt{excerpt}\" accesskey='e' tabindex='1' /><br />",
	      "BlogName: <input name='blog_name' value=\"$opt{blog_name}\" accesskey='n' tabindex='1' /><br />",
	      "<input type='hidden' name='charset' value='EUC-JP' />",
	      "<input type='submit' value='$message{trackback}' accesskey='w' tabindex='2' />",
	      "</p></form>";
}

#
# ȥåХåڡ
# $opt{url}
#
sub printTrackbackPage($%) {
	my($file, %opt) = @_;
	printError($message{trackback}) unless ($opt{url});
	printHeader($message{trackback}, deny_robot=>1);
	my @buf = readFile($file, 2);
	print "\n";
	trackbackForm( tburl=>$opt{url},
		       url=>"$ABS_URI_REWRITE/$file.html",
		       title=>$buf[0],
		       excerpt=>$buf[1],
		       blog_name=>$TITLE,
		     );
	printFooter();
}

#
# ե
# $arg{query}
#
sub searchForm(%) {
	my %opt = @_;
	my $query = (defined $opt{query})? $opt{query}: "";
	print "<form method='get' action='$SELF_URI'><p>",
	      "<input name='cmd' type='hidden' value='search' />",
	      "<input name='msg' size='19' value=\"$query\" tabindex='1' accesskey='q' />",
	      "<input type='submit' value='$message{search}' name='submit' tabindex='2' accesskey='s' />",
	      "</p></form>";

	my $gquery = $query;
	print "<form method='get' action='$GOOGLE_URI'><p>",
	      "<input name='q' size='19' value=\"$gquery\" tabindex='1' accesskey='g' />",
	      "<input type='hidden' name='ie' value='EUC-JP' />",
	      "<input type='submit' name='google' value='$message{google}' tabindex='1' accesskey='g' />",
	      "</p></form>";
}

#
# 
#
sub printSettingPage() {
	my $passwd = $cookie{PASSWD}? $cookie{PASSWD}: "";
	printHeader($message{setting}, deny_robot=>1);
	print "\n<form method='post' action='$SELF_URI?cmd=passwd'><h2>$message{passwd}</h2><p>",
	      "Old Password <input type='password' name='oldpasswd' size='19' value='$passwd' tabindex='1' accesskey='o' /><br />",
	      "New Password <input type='password' name='newpasswd' size='19' value='' tabindex='1' accesskey='n' /><br />",
	      "New Password <input type='password' name='newpasswd2' size='19' value='' tabindex='1' accesskey='m' /><br />",
	      "<input type='submit' value='$message{setting}' name='submit' tabindex='2' accesskey='w' />",
	      "</p></form>\n";

	my @keyword = readNamedFile("keyword");
	print "\n<form method='post' action='$SELF_URI?cmd=keyword'><h2>$message{keyword}</h2><p>",
	      "<textarea rows='8' cols='20' name='body' tabindex='8' accesskey='k'>",
	      join("\n", @keyword),
	      "</textarea><br />",
	      "$message{passwd}<input type='password' value='$passwd' name='passwd' tabindex='2' accesskey='p' /><br />",
	      "<input type='submit' value='$message{setting}' name='submit' tabindex='2' accesskey='w' />",
	      "</p></form>\n";
	printFooter();
}

#
# ѥɤ
#
sub passwd($$$) {
	my($old, $new, $new2) = @_;
	if ($new ne $new2) {
		printError($message{passwd});
	} elsif (! checkPasswd($old)) {
		printError($message{passwd});
	} else {
		setPasswd($new);
		$cookie{PASSWD} = $new;
		push @newcookie, "PASSWD";
	}
	print302("$SELF_URI?cmd=setting");
}

#
# ɤ
# $opt{passwd}
#
sub keyword($%) {
	my($body, %opt) = @_;
	printError($message{passwd}) unless (checkPasswd($opt{passwd}));
	writeNamedFile("keyword", $body);
	print302("$SELF_URI?cmd=setting");
}

#
# إ
#
sub printHelpPage() {
	printHeader($message{help});
	my $buf = "blogchϷǼBlogޤBlogηǼĤǤ\n" .
		  "ȤïǤ񤯤ȤǤޤ\n" .
		  "ȥåХåïǤǤޤ\n" .
		  "ԽեźդϴԤΤߤȤ뵡ǽǤ\n" .
		  "ϴԤΤߤïǤǤ뤫꼡Ǥ\n" .
		  "\n" .
		  "[[]]Ȥȸ󥯤ˤʤޤ\n" .
		  "ΤȤ¾εؤΥ󥯤ˤʤޤ\n" .
		  "http://www.google.co.jp/Ȥȥ󥯤ˤʤޤ\n" .
		  "\n" .
		  " * ǻϤޤԤϸФˤʤޤ\n" .
		  "ԤϤΤޤɽޤ\n" .
		  "\n" .
		  "ڡƤˤȺޤ\n" .
		  "\n" .
		  "ΡYukiWikiסΤ顣פ򻲹ͤˤޤ" .
		  "http://www.hyuki.com/\n" .
		  "(Fuktommy)Υڡhttp://fuktommy.s64.xrea.com/\n";
	$buf = html_format(escape($buf));
	print "<p>$buf</p>\n";
	printFooter();
}

#
# 
#
sub printSearchPage() {
	printHeader($message{search}, deny_robot=>1);
	searchForm();
	printFooter();
}

#
# 
#
sub printSearchResultPage($) {
	my($query) = @_;
	printHeader($message{search}, deny_robot=>1);
	print "<ul>\n";
	my %buf = search(unescape($query));
	foreach (sort {$b <=> $a} keys %buf) {
		my $title = escape($buf{$_});
		print "<li>", xlocaltime($_), " <a href='$SELF_URI_REWRITE/$_.html'>$title</a></li>\n";
	}
	print "</ul>";
	searchForm(query=>$query);
	printFooter();
}

#
# ᥤ
#
if (-d $Blogch::DATA_DIR) {
	# ok
} elsif (mkdir $Blogch::DATA_DIR, 0777) {
	# ok
} else {
	printError($Blogch::DATA_DIR);
	exit;
}

my %arg;
if ($ENV{REQUEST_METHOD} ne "POST") {
	%arg = args($ENV{QUERY_STRING});

} elsif ($ENV{CONTENT_TYPE} =~ m|multipart/form-data|) {
	my $input;
	read(STDIN, $input, $ENV{CONTENT_LENGTH});
	%arg = argsFromMulti($input);
	my %arg2 = args($ENV{QUERY_STRING});
	local $_;
	foreach (keys %arg2) {
		$arg{$_} = $arg2{$_};
	}

} else {
	my $input;
	read(STDIN, $input, $ENV{CONTENT_LENGTH});
	$input .= "&$ENV{QUERY_STRING}";
	%arg = args($input);
}

@newcookie = ();
%cookie = cookie($ENV{HTTP_COOKIE});
if ((defined $arg{passwd}) && ((! defined $cookie{PASSWD}) || ($arg{passwd} ne $cookie{PASSWD}))) {
	$cookie{PASSWD} = $arg{passwd};
	push @newcookie, "PASSWD";
}

my $path = (defined $ENV{PATH_INFO})? $ENV{PATH_INFO}: "";
if ($path =~ m|^/(\d+)\.html$|) {
	printPage($1);

} elsif ($path =~ m|^/(\d+)/(\d+)/$|) {
	printCalender($1, $2);

} elsif ((! defined $arg{cmd})||($arg{cmd} eq "")) {
	printRecent();

} elsif (($arg{cmd} eq "view") && ($arg{msg} =~ /^(\d+)$/)) {
	printPage($1);

} elsif ($arg{cmd} eq "index") {
	printIndex();

} elsif ($arg{cmd} eq "recent") {
	printRecent();

} elsif ($arg{cmd} eq "thismon") {
	printCalender();

} elsif ($arg{cmd} eq "rss") {
	printRss1Page();

} elsif ($arg{cmd} eq "setting") {
	printSettingPage();

} elsif ($arg{cmd} eq "help") {
	printHelpPage();

} elsif ($arg{cmd} eq "edit") {
	printEditPage($arg{msg});

} elsif (($arg{cmd} eq "new") && $ANONYMOUS_ENTORY) {
	printPage(time);

} elsif ($arg{cmd} eq "new") {
	printEditPage(time);

} elsif (($arg{cmd} eq "search") && (defined $arg{msg}) && ($arg{msg} ne "")) {
	printSearchResultPage($arg{msg});

} elsif ($arg{cmd} eq "search") {
	printSearchPage();

} elsif ($arg{cmd} eq "post") {
	post($arg{msg}, body=>$arg{body}, %arg);

} elsif ($arg{cmd} eq "comment") {
	comment($arg{msg}, body=>$arg{body});

} elsif ($arg{cmd} eq "passwd") {
	passwd($arg{oldpasswd}, $arg{newpasswd}, $arg{newpasswd2});

} elsif ($arg{cmd} eq "keyword") {
	keyword($arg{body}, passwd=>$arg{passwd});

} elsif ($arg{cmd} eq "trackback") {
	trackback($arg{msg}, %arg);

} elsif ($arg{cmd} eq "trackbackpage") {
	printTrackbackPage($arg{msg}, url=>$arg{url});

} else {
	printRecent();
}
